您的位置:首页 > 其它

Codeforces Round #416 (Div. 2) C. Vladik and Memorable Trip(dp)

2017-05-27 23:11 330 查看
C. Vladik and Memorable Trip

time limit per test
2 seconds

memory limit per test
256 megabytes

input
standard input

output
standard output

Vladik often travels by trains. He remembered some of his trips especially well and I would like to tell you about one of these trips:

Vladik is at initial train station, and now
n people (including Vladik) want to get on the train. They are already lined up in some order, and for each of them the city code
ai is known (the code of the city in which they are going to).

Train chief selects some number of disjoint segments of the original sequence of people (covering entire sequence by segments is
not necessary). People who are in the same segment will be in the same train carriage. The segments are selected in such way that if at least one person travels to the city
x, then all people who are going to city
x should be in the same railway carriage. This means that they can’t belong to different segments. Note, that all people who travel to the city
x, either go to it and in the same railway carriage, or do not go anywhere at all.

Comfort of a train trip with people on segment from position
l to position r is equal to
XOR of all distinct codes of cities for people on the segment from position
l to position r.
XOR operation also known as exclusive
OR.

Total comfort of a train trip is equal to sum of comfort for each segment.

Help Vladik to know maximal possible total comfort.

Input
First line contains single integer
n (1 ≤ n ≤ 5000) — number of people.

Second line contains n space-separated integers
a1, a2, ..., an (0 ≤ ai ≤ 5000),
where ai denotes code of the city to which
i-th person is going.

Output
The output should contain a single integer — maximal possible total comfort.

Examples

Input
6
4 4 2 5 2 3


Output
14


Input
9
5 1 3 1 5 2 4 2 5


Output
d7fe
9


Note
In the first test case best partition into segments is:
[4, 4] [2, 5, 2]
[3], answer is calculated as follows: 4 + (2
xor 5) + 3 = 4 + 7 + 3 = 14
In the second test case best partition into segments is:
5 1
[3] 1 5
[2, 4, 2] 5, answer calculated as follows:
3 + (2 xor 4) = 3 + 6 = 9.

题意: 给一个有n个人排队上车,去相同地方的人要么坐在同一个车厢,要不就不上车,问最大苏适度和是多少。苏适度是车厢内所有数组成的集合的抑或值。

分析:  因为同样数字的人要么上同一个车厢要不就不计算,所以在枚举划分车厢之前要先进行预处理。

处理出所有可行区间,然后计算出所有情况的xor,进行dp。

处理可行区间的方法,查看当前区间内含有的每种数的数量是否等于它们自己本身的总数量。

#include<stdio.h>
#include<string.h>
#include<map>
#include<vector>
#include<algorithm>
using namespace std;
int a[55555];
//map<int,int>q,p;
int q[55555];
int p[55555];
int vis[55555];
vector<int>v[55555];
int dp[55555];
int mp[5555][5555];
int main()
{
int n;
scanf("%d",&n);
for(int i=1;i<=n;i++)
{
v[i].clear();
scanf("%d",&a[i]);
q[a[i]]++;
}
memset(dp,0,sizeof(dp));
int t=1;
for(int i=1;i<=n;i++)
{
int sum=0,cnt=0;
memset(vis,0,sizeof(vis));
memset(p,0,sizeof(p));
for(int j=i;j<=n;j++)
{
p[a[j]]++;
if(q[a[j]]==p[a[j]])
cnt++;
if(!vis[a[j]])
sum++,vis[a[j]]=1;
if(sum==cnt)
v[j].push_back(i);
}
}
for(int i=1;i<=n;i++)
{
int xorr=0;
memset(vis,0,sizeof(vis));
for(int j=i;j<=n;j++)
{
if(!vis[a[j]])
xorr^=a[j],vis[a[j]]=1;
mp[i][j]=xorr;
}
}
for(int i=1;i<=n;i++)
{
dp[i]=dp[i-1];
for(int j=0;j<v[i].size();j++)
{
dp[i]=max(dp[i-1],dp[v[i][j]-1]+mp[v[i][j]][i]);
}
}
printf("%d\n",dp
);
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: